SystemOrganization addCategory: #ClassNamesAnalyzer!
SystemOrganization addCategory: #'ClassNamesAnalyzer-Examples'!
SystemOrganization addCategory: #'ClassNamesAnalyzer-Reports'!
SystemOrganization addCategory: #'ClassNamesAnalyzer-Tests'!
SystemOrganization addCategory: #'ClassNamesAnalyzer-Visualization'!

!String methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 5/7/2018 09:27'!
splitWithCamelCase
"
'GoodMoriningAmerica' splitWithCamelCase = (OrderedCollection with:'Good' with:'Morining' with:'America')"
"'GCOptimizer' splitWithCamelCase = (OrderedCollection with:'GC' with:'Optimizer')"
"'optimizerOfGC' splitWithCamelCase  = (OrderedCollection with:'optimizer' with: 'Of' with: 'GC')
"

	| pastIndex  tokens newWord |
	self flag:' must consider the case of multiple uppercase letters :FMGenerator'.
	tokens := OrderedCollection new.
	newWord := false.
	pastIndex := 1.
	2 to: self size do: [ :index | 
		((((self at: index) asciiValue) > 64 and: [ ((self at: index) asciiValue) < 91 ]) and:[newWord])
			ifTrue: [ tokens add: (self collect: [ :each | each ] from: pastIndex to: index-1).
				pastIndex := index.newWord := false]ifFalse:[newWord := true]] .
		tokens add:(self collect:[:each | each ] from: pastIndex to: self size).
		^tokens
! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
allSubInheritances
	|aCollection|
	aCollection := OrderedCollection new.
	aCollection addAll: subInheritances.
	^aCollection addAll: ((subInheritances collect: #from) flatCollect: #allSubInheritances);yourself! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
classNamesScanReport
	^self vocabularyScanner classNamesScanReport.! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
indiceOfTheClassInHierarchy
	^self classNamesScanReport indiceOfTheClassInHierarchy.! !

!FAMIXType methodsFor: '*classNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
indiceOfTheClassInSubHierarchy
	^self vocabularyScanner classNamesScanReport indiceOfTheClassInSubHierarchy.! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
isMetaRoot
	^self nameSuffix = 'Object'! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
isaRootClass
	^self superclass = nil or: [self superclass isMetaRoot].! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
nameSuffix
	^self name splitWithCamelCase last.! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
rootClass
	^self superclasses first.! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
scanClassNames
	^FAMIXClassScanner scan: self! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
superclasses
	self isaRootClass 
		ifTrue:[ ^ OrderedCollection with: self ]
		ifFalse: [ ^self superclass superclasses add: self;yourself ]! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
vocabularyScanner
|a|
a := 
	self privateState attributeAt: #vocabularyScanner ifAbsentPut: (nil).
	a ifNil: [ a := (self privateState attributeAt: #vocabularyScanner put: ( self scanClassNames )) value ].
	^a! !

!FAMIXType methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 08:34'!
vocabularyScanner: aFAMIXClassScanner 
	self privateState attributeAt: #vocabularyScanner put: aFAMIXClassScanner.! !

RTPopup subclass: #RTClassScanReportPopup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Visualization'!

!RTClassScanReportPopup methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 5/6/2018 10:09'!
initializeElement: element
	super initializeElement: element.
	element
		when: TRMouseEnter
		do: [ :event | 
			element outgoingEdges
				do: [ :each | each colorEdgesToSuperClassesIn: Color red "each color: (Color red)"  ] .
			element incomingEdges 
				do: [ :each | each colorEdgesToSubClassesIn: Color black ]].
	element
		when: TRMouseLeave
		do: [ :event | 
			element incomingEdges do:[: each | each colorEdgesToSubClassesIn: ((each from color adjustBrightness: -0.1) alpha: 0.1).
					].
			element outgoingEdges
				do: [ :each | each colorEdgesToSuperClassesIn: ((each from color adjustBrightness: -0.1) alpha: 0.1) ].
			element trachelShape signalUpdate ]
	"element
		when: TRMouseDragging
		do: [ :event | 
			self removeLastPopup.
			element trachelShape signalUpdate ]"! !

RTPopup subclass: #RTClassScanReportPopupWithoutSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Visualization'!

!RTClassScanReportPopupWithoutSubclasses methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 8/2/2018 13:04'!
initializeElement: element
	super initializeElement: element.
	element
		when: TRMouseEnter
		do: [ :event | 
			element outgoingEdges
				do: [ :each | each colorEdgesToSuperClassesIn: Color red  ] .
			].
	element
		when: TRMouseLeave
		do: [ :event | 
			element outgoingEdges
				do: [ :each | each colorEdgesToSuperClassesIn: ((each from color adjustBrightness: -0.1) alpha: 0.1) ].
			element trachelShape signalUpdate ]! !

RTPopup subclass: #RTSuffixScanReportPopup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Visualization'!

!RTSuffixScanReportPopup commentStamp: 'AbdelghaniAlidra 7/10/2018 11:16' prior: 0!
Useless. Please delete me!

TestCase subclass: #ClassNamesReportTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Tests'!

!FAMIXPackageGroup methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/8/2018 16:59'!
packageViewIn: composite
	<gtInspectorPresentationOrder: -10>
	<moosePresentationOrder: -20>
	composite roassal2
		title: 'NameBlueprint';
		initializeView: [ self vocabularyScanner classBluePrint ]! !

!MooseGroup methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 07:40'!
scanClassNames
	^FAMIXPackagesGroupScanner scan: self.! !

!MooseGroup methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 07:40'!
vocabularyScanner
|a|
a := 
	self privateState attributeAt: #vocabularyScanner ifAbsentPut: (nil).
	a ifNil: [ a := (self privateState attributeAt: #vocabularyScanner put: (FAMIXPackagesGroupScanner scan: self)) value ].
	^a! !

!MooseGroup methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 07:40'!
vocabularyScanner: aFAMIXPackagesGroupScanner 
	self privateState attributeAt: #vocabularyScanner put: aFAMIXPackagesGroupScanner! !

!FAMIXScopingEntity methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 07:35'!
scanClassNames
	^FAMIXPackageScanner scan: self! !

!FAMIXScopingEntity methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 07:35'!
vocabularyScanner
|a|
a := 
	self privateState attributeAt: #vocabularyScanner ifAbsentPut: (nil).
	a ifNil: [ a := (self privateState attributeAt: #vocabularyScanner put: (FAMIXPackageScanner scan: self)) value ].
	^a! !

!FAMIXScopingEntity methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/5/2018 07:35'!
vocabularyScanner: aFAMIXClassScanner 
	self privateState attributeAt: #vocabularyScanner put: aFAMIXClassScanner.! !

Dictionary subclass: #VocabularyScanReport
	instanceVariableNames: 'subEntityScanReports scannedEntity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Reports'!

VocabularyScanReport subclass: #ClassScanReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Reports'!

!ClassScanReport methodsFor: 'visualization-private' stamp: 'AbdelghaniAlidra 8/2/2018 11:48'!
affectIndicesToSubhierarchyClasses: aDoubleEntryDictionary
	| aDictionary i |
	aDictionary := Dictionary new.
	aDoubleEntryDictionary do: [ :aDico | 
			i := 1.
			aDico do: [ :subClassesOfSubRoot | 
					subClassesOfSubRoot do: [ :each | aDictionary at: (each at: 'className') put: i ].
					i := i + 1 ] ].
	^ aDictionary! !

!ClassScanReport methodsFor: 'visualization-private' stamp: 'AbdelghaniAlidra 8/2/2018 09:26'!
affectRandomColorsTo: subRootClasses
	 
	| dicoOfColors |
	dicoOfColors := Dictionary new.
	subRootClasses do: [:each| dicoOfColors at: (each at: 'className') put: Color random].
	^dicoOfColors! !

!ClassScanReport methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/27/2018 14:30'!
allHierarchySuffixes
	^(self at: 'rootClass') classNamesScanReport hierarchieSuffixesAndClasses keys! !

!ClassScanReport methodsFor: 'visualization-private' stamp: 'AbdelghaniAlidra 8/2/2018 12:38'!
buildHierarchyBlueprintOf: aDicoOfSuffixesAndSubhierarchies using: dicoOfColors and: dicoOfVisualElementsIndices
	| view allHierarchieClasses aDicoOfSuffixesAndClasses layers |
	view := RTView new.
	view @ RTDraggableView.
	view @ RTZoomableView.
	aDicoOfSuffixesAndClasses := (aDicoOfSuffixesAndSubhierarchies keys
		collect:
			[ :aSuffix | aSuffix -> ((aDicoOfSuffixesAndSubhierarchies at: aSuffix) values flatCollect: #yourself) ])
		asDictionary.
	allHierarchieClasses := aDicoOfSuffixesAndClasses values flatCollect: #yourself.
	layers := self createLayersFor: aDicoOfSuffixesAndClasses with: dicoOfColors in: view.
	self setDimentionsOf: layers.
	self nestLayers: layers with: dicoOfVisualElementsIndices.
	allHierarchieClasses do: [ :aClass | self createEdgesFor: aClass on: view ].
	^ view! !

!ClassScanReport methodsFor: 'Visualisation' stamp: 'AbdelghaniAlidra 7/14/2018 19:59'!
classReportViewIn: composite
	<gtInspectorPresentationOrder: -10>
	<moosePresentationOrder: -20>
	composite roassal2
		title: 'NameBlueprint';
		initializeView: [ self hierarchicalVisualisationWithCouleredSuffixes]
! !

!ClassScanReport methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/29/2018 10:04'!
classesGroupedBySuffixes
	| classes aCollection aDico |
	classes := self classesGroupedBySuffixesAndSubhierarchies.
	aCollection := OrderedCollection new.
	aDico := Dictionary new.
	classes keys
		do: [ :aSuffix | aDico at: aSuffix put: ((classes at: aSuffix) values flatCollect: #yourself) ].
	^aDico! !

!ClassScanReport methodsFor: 'queries' stamp: 'AbdelghaniAlidra 8/2/2018 09:27'!
classesGroupedBySuffixesAndSubhierarchies
	| aDoubleEntryDictionary |
	aDoubleEntryDictionary := Dictionary new.
	self hierarchieSuffixesAndClasses associations do: [ :aSuffixAndClasses| | suffix collectionOfClasses | 
		suffix := aSuffixAndClasses key.
		aDoubleEntryDictionary at: suffix put: Dictionary new.
		collectionOfClasses := aSuffixAndClasses value.
		collectionOfClasses do:[:aClass| 
			|subRoot|
			subRoot := (aClass at: 'superclasses') reversed at: (aClass indiceOfTheClassInSubHierarchy).
			
			(aDoubleEntryDictionary at: suffix) at: subRoot ifPresent: [ ((aDoubleEntryDictionary at: suffix) at: subRoot) add: aClass  ] ifAbsent: [  (aDoubleEntryDictionary at: suffix) at: subRoot put: (OrderedCollection with: aClass)] ]
		].
	^aDoubleEntryDictionary! !

!ClassScanReport methodsFor: 'visualization-private' stamp: 'AbdelghaniAlidra 10/8/2018 17:20'!
createEdgesFor: aClass on: view
	| eb |
	"Dont display ingoing edges for subRoot classes"
	eb := RTEdgeBuilder new.
	eb view: view.
	eb shape line width: 0.1; color: (aClass indiceOfTheClassInHierarchy = 1 
	ifTrue: Color transparent ifFalse: ((Color black adjustBrightness: -0.1) alpha: 0.1)).
	eb connectFrom: aClass  to: ((aClass at: 'superclasse') ifNotNil: [(aClass at: 'superclasse') classNamesScanReport])  ! !

!ClassScanReport methodsFor: 'visualization-private' stamp: 'AbdelghaniAlidra 8/2/2018 12:39'!
createLayersFor: aDicoOfSuffixesAndClasses with: dicoOfColors in: view
	| orderedSuffixes nodes |
	orderedSuffixes := self orderSuffixesAccordingToLongestSubHierarchy: aDicoOfSuffixesAndClasses.
	^orderedSuffixes collect: [:aSuffix | | layer |
	layer := (RTElement on: aSuffix)
				+ (RTBox new borderColor: Color gray; color: Color transparent); @ RTPopup.
				
	nodes := (aDicoOfSuffixesAndClasses at: aSuffix) collect: [ :aClassReport| 
		| supposedSubRoot |
		supposedSubRoot := ((aClassReport at: 'superclasses') reversed detect: [ :each | each indiceOfTheClassInHierarchy = 1 ]) name .
		(RTElement on: aClassReport) + (RTBox new color: (dicoOfColors at: supposedSubRoot); borderWidth: ((aClassReport at: 'isRoot') ifTrue: [1] ifFalse: [0]); borderColor: Color black; width: 1; height: 1); @ aClassReport mouseAnnouncerWithoutSubclasses; @ RTDraggable].
	view add: layer.
	view addAll: nodes.
	(layer -> nodes)
		].! !

!ClassScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/14/2018 17:39'!
groupOfPackagesScanReport
	"Ugly hack. Should be removed once suffixes are grouped in a dedicated report"
	^self scannedEntity mooseModel allPackages scanClassNames classNamesScanReport! !

!ClassScanReport methodsFor: 'Visualisation' stamp: 'AbdelghaniAlidra 7/30/2018 17:17'!
hierarchicalVisualisationWithCouleredSuffixes
	| b allHierarchyClasses allPackages aDico |
	aDico := Dictionary new.
allHierarchyClasses := ((((self at: 'rootClass') allSubInheritances collect: #from) addFirst: (self at: 'rootClass'); yourself) collect: #vocabularyScanner) collect: #classNamesScanReport.	
allPackages := (allHierarchyClasses collect: [ :each | each at: 'package' ]) asSet.

b := RTMondrian new.
b shape rectangle withTextAbove: [:each| each name];
color: Color transparent;
borderColor: Color gray.
b nodes: allPackages forEach: [ 
	:aPackage |
	b shape rectangle "withTextAbove: [:aReport | '']";
	size: 40;
	color: [ :aReport | 
					aDico at: (aReport at: 'classSuffix') ifAbsentPut: Color random].

	b nodes: (allHierarchyClasses select: [ :aReport | (aReport at: 'package') = aPackage ] ).
	b layout tree.
	
	b edges connectFrom: [ :each|
	 (each at: 'superclasse') vocabularyScanner classNamesScanReport]
	].
b view elements do: [:element| element removeConnectedEdges].

	b view elements do: [ :element| element announcer subscriptions  subscriptions do: [ :each | element announcer subscriptions  subscriptions remove: each ]].
	b view elements do: [ :element| element @ (element model mouseAnnouncer)].
b layout tree.

b shape line color: (Color gray).
b edges: allHierarchyClasses from: #yourself to: [ :aClassScanReport| (aClassScanReport at: 'superclasse') ifNotNil: [ (aClassScanReport at: 'superclasse') vocabularyScanner classNamesScanReport ] ].
b shape line color: (Color transparent).
b edges connectFromAll: [ :aPackage| 
	 aPackage queryOutgoingInheritances atPackageScope withoutSelfLoops asSet
	 ].



^b


! !

!ClassScanReport methodsFor: 'queries' stamp: 'AbdelghaniAlidra 7/31/2018 07:01'!
hierarchieBluePrintViewIn: composite
	<gtInspectorPresentationOrder: -11>
	<moosePresentationOrder: -21>
	composite roassal2
		title: 'HierarchieBlueprint';
		initializeView: [ self hierarchieBlueprint ]
! !

!ClassScanReport methodsFor: 'Visualisation' stamp: 'AbdelghaniAlidra 8/2/2018 12:44'!
hierarchieBlueprint
|  allHierarchieClasses subRootClasses aDico dicoOfVisualElementsIndices dicoOfColors |

	allHierarchieClasses := self hierarchieSuffixesAndClasses values flatCollect: #yourself.
	subRootClasses := allHierarchieClasses  select: [ :aScanReport | aScanReport indiceOfTheClassInSubHierarchy = 1 ].
	dicoOfColors := self affectRandomColorsTo: subRootClasses.
	aDico := self classesGroupedBySuffixesAndSubhierarchies.
	dicoOfVisualElementsIndices := self affectIndicesToSubhierarchyClasses: aDico.
	aDico := self classesGroupedBySuffixesAndSubhierarchies.
	^self buildHierarchyBlueprintOf: aDico using: dicoOfColors and: dicoOfVisualElementsIndices.
! !

!ClassScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/30/2018 23:22'!
hierarchieSuffixesAndClasses
	| allHierarchieClasses dico |
	dico := Dictionary new.
	allHierarchieClasses := ((self at: 'rootClass' )allSubInheritances collect: [:anAssociation | anAssociation from classNamesScanReport]) addFirst: (self at: 'rootClass') classNamesScanReport;yourself.
	allHierarchieClasses collect: [ :aScanReport | dico at: (aScanReport at: 'classSuffix') ifPresent: [ (dico at: (aScanReport at: 'classSuffix')) add: aScanReport  ] ifAbsentPut: [ OrderedCollection with: aScanReport ] ].
	^dico
	
! !

!ClassScanReport methodsFor: 'queries' stamp: 'AbdelghaniAlidra 7/31/2018 06:57'!
indiceOfTheClassInHierarchy
	| indiceOfSuperclass subclassesWithSameSuffix aDico i mySuffix subclassesWithSameSuffixIndices myIndice |
	
	^self at: 'indiceOfTheClassInHierarchy' ifAbsent:[
		
	(self indiceOfTheClassInSubHierarchy = 1) ifTrue: [^self at: 'indiceOfTheClassInHierarchy' put: 1].
	indiceOfSuperclass := (self at: 'superclasse') indiceOfTheClassInHierarchy.
	mySuffix := self at: 'classSuffix'.
	subclassesWithSameSuffix := ((self at: 'rootClass') allSubInheritances collect: [:each | each from classNamesScanReport]) select: [:each | (each at: 'classSuffix') = mySuffix].
	subclassesWithSameSuffixIndices := subclassesWithSameSuffix collect: [ :each | each at: 'indiceOfTheClassInHierarchy' ifAbsent: 0 ].
	
	myIndice := (subclassesWithSameSuffixIndices max max: indiceOfSuperclass) + 1.	
	^self at: 'indiceOfTheClassInHierarchy' put: myIndice ]! !

!ClassScanReport methodsFor: 'queries' stamp: 'AbdelghaniAlidra 7/31/2018 02:07'!
indiceOfTheClassInSubHierarchy
	"answers the order of the class in the subhierarchy of its suffix.
	"
	| i j superclasses |
	i := 2.
	j := 1.
	superclasses := (self at: 'superclasses') reversed.
 	[ i <= superclasses size ]
		whileTrue: [ (((superclasses at: i) classNamesScanReport at: 'classSuffix') = (self at: 'classSuffix')) ifTrue: [j:= i]. "j receives i if a subRoot with the same suffix exists"
			i := i + 1 ].
	^ j! !

!ClassScanReport methodsFor: 'Visualisation' stamp: 'AbdelghaniAlidra 7/10/2018 14:55'!
mouseAnnouncer
	^RTClassScanReportPopup new text: self viewInClassBluePrint; alphaPopupBackground: 0.7; textColor: Color green; backgroundColor: Color black! !

!ClassScanReport methodsFor: 'Visualisation' stamp: 'AbdelghaniAlidra 8/2/2018 12:42'!
mouseAnnouncerWithoutSubclasses
	^RTClassScanReportPopupWithoutSubclasses new text: self viewInClassBluePrint; alphaPopupBackground: 0.7; textColor: Color green; backgroundColor: Color black! !

!ClassScanReport methodsFor: 'visualization-private' stamp: 'AbdelghaniAlidra 8/2/2018 12:37'!
nestLayers: layers with: dicoOfVisualElementsIndices
	RTHorizontalLineLayout new
		gapSize: 0;
		on: (layers collect: #key).
	RTAlignment new elements: (layers collect: #key); top.
	
	layers
		do: [ :layer|
			layer value do: [ :anElement|
				| x y classScanReport indiceOfSubHierarchy |
				classScanReport := anElement model.
				indiceOfSubHierarchy := dicoOfVisualElementsIndices at: (classScanReport at: 'className').
				x := indiceOfSubHierarchy  -1 * 2 + (3/2).
				y := classScanReport indiceOfTheClassInHierarchy - 1 * 2 + (3/2).
				anElement trachelShape position: layer key encompassingRectangle origin + (x@y).
				 ]
			]! !

!ClassScanReport methodsFor: 'visualization-private' stamp: 'AbdelghaniAlidra 8/2/2018 10:38'!
orderSuffixesAccordingToLongestSubHierarchy: aDicoOfSuffixesAndClasses

	| allSuffixes |
	allSuffixes := aDicoOfSuffixesAndClasses keys.
	^allSuffixes
		sort: [ :first :second | 
			| firstSuffixIndiceOfClasses secondSuffixIndiceOfClasses |
			firstSuffixIndiceOfClasses := ((aDicoOfSuffixesAndClasses at: first)
				collect: #indiceOfTheClassInHierarchy) max.
			secondSuffixIndiceOfClasses := ((aDicoOfSuffixesAndClasses at: second)
				collect: #indiceOfTheClassInHierarchy) max.
			firstSuffixIndiceOfClasses > secondSuffixIndiceOfClasses ]! !

!ClassScanReport methodsFor: 'storage' stamp: 'AbdelghaniAlidra 10/5/2018 03:46'!
saveClassNameInformationTo: aMultiByteFileStream 
	aMultiByteFileStream << (self at: 'className') << ';'
	<< ((self at: 'rootClass') name) << ';'
	<< (self at: 'CLASSNAME_usesSameSuffixeAsRoot') << ';'
	<< (self at: 'CLASSNAME_isFalsePositive') << ';'
	<< (self at: 'CLASSNAME_isNamedConsistently') << ';'
	<< (self at: 'CLASSNAME_noteOnCoherence' ) << ';'
	<< (self at: 'CLASSNAME_canBeFixedConformingToUnicityHypothesis').
	aMultiByteFileStream crlf.
	
" CLASSNAME_usesAdifferentSuffixeThanRoot;CLASSNAME_isFalsePositive;CLASSNAME_isNamedInconsistently;CLASSNAME_noteOnCoherence;CLASSNAME_canBeFixedConformingToUnicityHypothesis"! !

!ClassScanReport methodsFor: 'storage' stamp: 'AbdelghaniAlidra 9/30/2018 23:50'!
saveTo: aMultiByteFileStream 
	aMultiByteFileStream << (self at: 'className') << ';'
	<< (self at: 'HIERARHCY_usesManySuffixes') << ';'
	<< (self at: 'HIERARHCY_isFalsePositive') << ';'
	<< (self at: 'HIERARHCY_isNamedInconsistently') << ';'
	<< (self at: 'HIERARHCY_noteOnCoherence' ) << ';'
	<< (self at: 'HIERARHCY_canBeFixedConformingToUnicityHypothesis').
	aMultiByteFileStream crlf! !

!ClassScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/26/2018 00:17'!
scannedClass
	^self at: 'scannedClasses'.! !

!ClassScanReport methodsFor: 'visualization-private' stamp: 'AbdelghaniAlidra 8/2/2018 12:21'!
setDimentionsOf: aCollection 

	| height |
	height := ((aCollection flatCollect: #value) collect: [:element| element model indiceOfTheClassInHierarchy ]) max * 2 + 1.
	aCollection do: [ :layer|
		| numberOfSubhierarchies width |
		numberOfSubhierarchies := (layer value select: [ :element| element model indiceOfTheClassInHierarchy = 1 ]) size.
		width := numberOfSubhierarchies * 2 + 1.
		layer key  height: height.
		layer key width: width
		 ]! !

!ClassScanReport methodsFor: 'Visualisation' stamp: 'AbdelghaniAlidra 5/4/2018 23:05'!
viewInClassBluePrint
	^'className: ',(self at: 'className'), String cr,
	 'superclass: ',(self at: 'superclasse') name, String cr,
	 'Root Class: ',(self at: 'rootClass') name. ! !

VocabularyScanReport subclass: #GroupOfPackagesScanReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Reports'!

!GroupOfPackagesScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 16:47'!
singlePackageScanReports
	^ self subEntityScanReports! !

!GroupOfPackagesScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 16:49'!
singlePackageScanReports: aGroupOfReports
	self subEntityScanReports: aGroupOfReports! !

VocabularyScanReport subclass: #PackageScanReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Reports'!

!PackageScanReport methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 4/27/2018 16:48'!
classScanReports
	^self subEntityScanReports! !

!PackageScanReport methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 4/27/2018 16:49'!
classScanReports: aGoupOfReports
	^self subEntityScanReports: aGoupOfReports! !

!PackageScanReport methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 7/28/2018 15:57'!
sortSuffixes: unSortedSuffixes 
|colorClusters temp result|
result := OrderedCollection new.
temp := unSortedSuffixes.
colorClusters := Dictionary new.
temp do:[:aSuffix| colorClusters at: (aSuffix value dominantHierarchieInPackage: self scannedEntity) "key first" ifPresent: [(colorClusters at:(aSuffix value dominantHierarchieInPackage: self scannedEntity)) add: aSuffix value] ifAbsentPut: (OrderedCollection with: aSuffix value)].

colorClusters do:[:anArray| anArray sort: [:first :second| 
		(((first packagesWithClasses at: self scannedEntity) detect: [ :each | (each at: 'isRoot')] ifNone: [ nil ]) isNotNil ) 
		or:(first packagesWithClasses at: self scannedEntity) size > (second packagesWithClasses at: self scannedEntity) size ]].

(colorClusters values sort: [ :first :second | first size > second size ]) do:[:anArray| result addAll: anArray].
^result! !

VocabularyScanReport subclass: #SuffixScanReport
	instanceVariableNames: 'suffix classes classNames hierarchies packages classScanReports dominantHierarchieInPackages packagesWithClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Reports'!

!SuffixScanReport class methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 7/9/2018 22:51'!
with: aSingleClassScanReport
	^self new
		classScanReports: (Set with: aSingleClassScanReport)
		"classNames: (Set with: (aSingleClassScanReport at: 'className'));
		classes: (Set with: (aSingleClassScanReport at: 'scannedClasses'));
		hierarchies: (Bag with: (aSingleClassScanReport at: 'rootClass'));
		suffix: (aSingleClassScanReport at: 'classSuffix'); 
		packages: (Set with: (aSingleClassScanReport at: 'package'))"! !

!SuffixScanReport methodsFor: 'visualization' stamp: 'AbdelghaniAlidra 7/25/2018 10:51'!
SuffixViewIn: composite
	<gtInspectorPresentationOrder: -10>
	<moosePresentationOrder: -20>
	composite roassal2
		title: 'SuffixBlueprint';
		initializeView: [ self layeredSuffixBlueprint ]! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 22:55'!
classNames
	^ classNames ifNil: [ classNames := classScanReports collect: [ :each| each at: 'className' ] ]! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:04'!
classScanReports
	^ classScanReports! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 22:52'!
classScanReports: aSet
	classScanReports := aSet! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 22:58'!
classes
	^ classes ifNil: [ classes := classScanReports collect: [ :each| each at: 'className' ] ]! !

!SuffixScanReport methodsFor: 'visualization' stamp: 'AbdelghaniAlidra 7/24/2018 21:15'!
dominanceLevel 
	^0.8! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:35'!
dominantHierarchie
	^self dominantHierarchies first! !

!SuffixScanReport methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 7/28/2018 15:34'!
dominantHierarchieInPackage: aFAMIXPackage 
	^((self packagesWithClasses at: aFAMIXPackage) collect: [ :each | each at: 'rootClass' ]) asBag sortedCounts first value
	
	! !

!SuffixScanReport methodsFor: 'statistics' stamp: 'AbdelghaniAlidra 10/8/2018 17:15'!
dominantHierarchieInPackages
	|associationsOfPackagesAndHierarchies numberOfclassesBelongingToDominantHierarchy|
	^dominantHierarchieInPackages ifNil:
	[associationsOfPackagesAndHierarchies := classScanReports asBag collect: [ :each| (each at: 'package')->(each at: 'rootClass') ].
	numberOfclassesBelongingToDominantHierarchy := (associationsOfPackagesAndHierarchies select: [ :each| each value = self dominantHierarchie key first]).
	dominantHierarchieInPackages := self packages collect: [:each| each -> ((numberOfclassesBelongingToDominantHierarchy select: [:ass| ass key = each ]) size / (classScanReports select: [ :report| (report at: 'package') = each]) size) ]]! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:44'!
dominantHierarchies

	^self hierarchies sortedCounts collect: [ :association| {association value . association value parentPackage} -> (association key/self hierarchies size) ]! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:09'!
hierarchies
	^ hierarchies ifNil: [ hierarchies := classScanReports asBag collect: [ :each| each at: 'rootClass' ] ]! !

!SuffixScanReport methodsFor: 'visualization' stamp: 'AbdelghaniAlidra 7/28/2018 15:46'!
layeredSuffixBlueprint
	| index sortedPackages sortedHierarchies dictionaryOfHierarchiesIndices dictionaryOfPackageIndices view nodes layers |
	index := 0.
	sortedPackages := (self dominantHierarchieInPackages
		asOrderedCollection
		sort: [ :first :second | first value > second value ]) collect: #key.
	sortedHierarchies := self dominantHierarchies.
	dictionaryOfHierarchiesIndices := (sortedHierarchies
		collect: [ :each | 
			index := index + 1.
			each key first -> index ]) asDictionary.
	index := 0.
	dictionaryOfPackageIndices := (sortedPackages
		collect: [ :each | 
			index := index + 1.
			each -> index ]) asDictionary.
	view := RTView new.
	view @ RTDraggableView.
	view @ RTZoomableView.
	layers := sortedPackages
		collect: [ :aPackage | 
			| layer |
			layer := (RTElement on: aPackage)
				+ (RTBox new borderColor: Color gray; color: Color transparent); @ RTPopup.
			nodes := (self packagesWithClasses at: aPackage) collect: [ :aClass|
				|colorOfHierarchy| 
				colorOfHierarchy := (aClass at: 'scannedClasses') mooseModel dictionaryOfRootClassColors at: (aClass at: 'rootClass').
				(RTElement on: aClass) + (RTBox new color: colorOfHierarchy; borderWidth: ((aClass at: 'isRoot') ifTrue: [1] ifFalse: [0]); borderColor: Color black; width: 1; height: 1); @ aClass mouseAnnouncer; @ RTDraggable.].
				view add: layer.
				view addAll: nodes.
				(layer -> nodes)
			].
	layers do: [ 
		 :layer | 
RTTreeLayout new
layered.
layer value do: [ :node| node @ RTDraggableChildren ].
RTNest new
"centerOn: layer key elements: layer value;"
makeElements: layer value draggableBy: layer key 
		 ]	.
	
layers do: [ :each| 
	|sortedElements|
	each key width: (sortedHierarchies size) * 2 + 1 ; height: ((self packagesWithClasses at: each key model) size) * 2 + 1.
	sortedElements := each value sort: [ :first :second | first model at: 'isRoot' ].
	(1 to: sortedElements size) do: [ :i| 
		| indiceOfHierarchy x y |
		indiceOfHierarchy := dictionaryOfHierarchiesIndices at: ((sortedElements at: i) model at: 'rootClass').
		
		x := indiceOfHierarchy  -1 * 2 + (3/2).
		y := i - 1 * 2 + (3/2).
		
		(sortedElements at: i) trachelShape position: each key encompassingRectangle origin + (x@y).
		]
	
	 ].

RTVerticalLineLayout new
gapSize: 0;
on: (layers collect: #key).

"TRConstraint setAllToMaxHeight: (layers collect: #key)."
RTResize new elements: (layers collect: #key); sameWidth;left.


		^view
		! !

!SuffixScanReport methodsFor: 'statistics' stamp: 'AbdelghaniAlidra 7/9/2018 23:05'!
mergeWith: aCollection 
	aCollection do: [ :each| each suffix = suffix ifFalse: ["Fatal error: trying to merge two different suffixes in one"self halt.]].
	self classScanReports addAll: (aCollection flatCollect: #classScanReports).
	self resetClasses.
	self resetClassNames.
	self resetHierarchies.
	self resetPackages.! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/10/2018 00:25'!
mouseAnnouncer
	^RTSuffixScanReportPopup new text: self viewInClassBluePrint! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:07'!
numberOfClasses
	^self classes size.! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:01'!
packages
	^ packages ifNil: [ packages := classScanReports collect: [ :each| each at: 'package' ] ]! !

!SuffixScanReport methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 7/28/2018 15:32'!
packagesWithClasses
^packagesWithClasses ifNil:[
	|aDictionary|
aDictionary := Dictionary new.
self classScanReports do: [ :each| aDictionary at: (each at: 'package') ifPresent: [ (aDictionary at: (each at: 'package')) add: each ] ifAbsentPut: [ OrderedCollection with: each ]  ].
packagesWithClasses := aDictionary
]! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:06'!
resetClassNames
	classNames := nil! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:05'!
resetClasses
	classes := nil! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:06'!
resetHierarchies
	hierarchies := nil! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 23:06'!
resetPackages
	packages := nil! !

!SuffixScanReport methodsFor: 'exporting' stamp: 'AbdelghaniAlidra 10/7/2018 19:50'!
saveTo: aMultiByteFileStream 
	aMultiByteFileStream << (self suffix) << ';'
	<< (self at: 'isUsedInManyHierarchies') << ';'
	<< (self at: 'isFalsePositive') << ';'
	<< (self at: 'isTrueAmbiguous') << ';'
	<< (self at: 'note' ) << ';'
	<< (self at: 'canBeFixedConformingToUnicityHypothesis').
	aMultiByteFileStream crlf! !

!SuffixScanReport methodsFor: 'visualization' stamp: 'AbdelghaniAlidra 7/25/2018 08:03'!
simpleGridLayoutVisualisation
|b|
b := RTMondrian new.

b shape rectangle withTextAbove: [:aSuffix| 'suffix: ', aSuffix suffix].
b shape color: [ :aSuffix| self value hierarchies anyOne mooseModel dictionaryOfRootClassColors at: self value dominantHierarchie key first].
b nodes: {self value}
forEach: [:e |
b shape rectangle withTextAbove: #name.
b nodes: self value packages forEach: [ :aPackage|
	b shape rectangle size: [:each| each key * 10].
	b shape withTextAbove: [ :each| each value name ].
	b shape color: [ :each| each value mooseModel dictionaryOfRootClassColors at: each value ].
	b nodes: ((aPackage  vocabularyScanner classNamesScanReport at: 'dominantRootsInSuffix') at: self value suffix) ].
b layout grid.
].
^b! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 22:57'!
suffix
	^ suffix ifNil: [ suffix := classScanReports anyOne at: 'classSuffix' ]! !

!SuffixScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/8/2018 08:54'!
suffix: aString 
	suffix := aString ! !

!SuffixScanReport methodsFor: 'visualization' stamp: 'AbdelghaniAlidra 7/24/2018 21:15'!
viewInClassBluePrint
	|dominantHierarchyStatName packageOfDominantHierarchy RatioOfClassesBelongingToDominantHierarchy hierarchyDominantedpackages mediumDominanceInDominatedPackages mediumDominanceInDominatedPackagesMsg numberOfClassesUsingThisSuffixInTheDominatedPackage |
	dominantHierarchyStatName := self dominantHierarchie key first name.
	packageOfDominantHierarchy := self dominantHierarchie key second name.
	RatioOfClassesBelongingToDominantHierarchy := (self dominantHierarchie value * 100) asFloat rounded asString, '% '.
	
	
	hierarchyDominantedpackages := (self dominantHierarchieInPackages select: [ :asso|
	asso value > self dominanceLevel
	 ]).

hierarchyDominantedpackages ifNotEmpty:[ mediumDominanceInDominatedPackages := (hierarchyDominantedpackages inject: 0 into: [ :sum :each| sum + each value ]) / hierarchyDominantedpackages size.
	numberOfClassesUsingThisSuffixInTheDominatedPackage := (self classScanReports select: [ :each| (hierarchyDominantedpackages collect: #key) includes: (each at: 'package')]) size.
	mediumDominanceInDominatedPackagesMsg := (mediumDominanceInDominatedPackages * 100) asFloat rounded asString, '% of the ', numberOfClassesUsingThisSuffixInTheDominatedPackage asString, ' classes using this suffix in these packages are subclasses of the dominant hierarchy']
ifEmpty: [ |maxDominance|
	maxDominance := (self dominantHierarchieInPackages collect: #value)max.
	mediumDominanceInDominatedPackages := self dominantHierarchieInPackages select: [ :each| each value >= (1/2)"maxDominance" ].
	 mediumDominanceInDominatedPackagesMsg := 'Only ', mediumDominanceInDominatedPackages size asString, 'package(s) associate this suffix to the dominant hierarchy in ', (maxDominance*100) asFloat rounded asString, '% of cases' ] .
	^'Suffix: ',(self suffix), String cr,
	
	 RatioOfClassesBelongingToDominantHierarchy, 'of the ', self classes size asString, ' classes using this suffix are subclasses of ', packageOfDominantHierarchy, '>>', dominantHierarchyStatName, String cr,
	
self dominantHierarchies size asString, 'hierarchies use this suffix', String cr,
self dominantHierarchieInPackages size asString , ' package(s) use this suffix', String cr,
'out of which ', hierarchyDominantedpackages size asString, ' package(s) associate it to the dominant hierarchy at more than ', (self dominanceLevel * 100) asString ,'%', String cr,
mediumDominanceInDominatedPackagesMsg! !

!SuffixScanReport methodsFor: 'visualization' stamp: 'AbdelghaniAlidra 7/25/2018 11:07'!
viewInMooseIn: composite 
	
	composite roassal2
		title: 'SuffixBlueprint';
		initializeView: [ self layeredSuffixBlueprint]! !

!VocabularyScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/8/2018 05:57'!
= aReport
	^ aReport ifNotNil: [scannedEntity = aReport scannedEntity]
	ifNil:[false]! !

!VocabularyScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/30/2018 14:24'!
scannedEntity
	^ scannedEntity! !

!VocabularyScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/30/2018 14:22'!
scannedEntity: aFAMIXPackageGroup 
	scannedEntity := aFAMIXPackageGroup! !

!VocabularyScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/29/2018 23:23'!
subEntityScanReports
	^ subEntityScanReports! !

!VocabularyScanReport methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 16:50'!
subEntityScanReports: aMooseGroup 
	subEntityScanReports := aMooseGroup! !

!RTEdge methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 5/6/2018 09:58'!
colorEdgesToSubClassesIn: aColor 
	self color: aColor.
	self from incomingEdges do: [:each| each colorEdgesToSubClassesIn: aColor] ! !

!RTEdge methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 5/6/2018 09:48'!
colorEdgesToSuperClassesIn: aColor 
	self color: aColor.
	self to outgoingEdges do: [:each| each colorEdgesToSuperClassesIn: aColor] ! !

!Association methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 7/10/2018 14:55'!
mouseAnnouncer

	^RTPopup new text: self value viewInClassBluePrint; alphaPopupBackground: 0.7; textColor: Color green; backgroundColor: Color black! !

!Association methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 5/4/2018 22:06'!
viewInClassBluePrint
	^value! !

!Association methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 7/25/2018 11:04'!
viewInMooseIn: composite
	<gtInspectorPresentationOrder: -10>
	<moosePresentationOrder: -20>
	value viewInMooseIn: composite! !

!RTAbstractElementHandling methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 7/30/2018 17:15'!
alignFromLeftUsing: anElement
	| topX newX |
	topX := anElement encompassingRectangle topLeft x.
	elements do: [ :s |
		newX := topX + (s encompassingRectangle width / 2).
		s translateTo: newX @ s position y
	]! !

!RTAbstractElementHandling methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 7/30/2018 17:10'!
hasElement
	"Return true if some elements have been set"
	^ (elements isNil or: [ elements isEmpty ]) not! !

!RTAbstractElementHandling methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 7/30/2018 17:09'!
left
	self hasElement ifFalse: [ ^ self ].
	self alignFromLeftUsing: self leftMostElement ! !

!RTAbstractElementHandling methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 7/30/2018 17:13'!
leftMostElement
	fixedElement ifNotNil: [ ^ fixedElement ].
	^ elements inject: elements first into: [ :maxS :s | 
			maxS encompassingRectangle left >= s encompassingRectangle left
					ifTrue: [ s ] ifFalse: [ maxS ] ] ! !

!MooseModel methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 7/28/2018 19:43'!
dictionaryOfRootClassColors

	^self privateState attributeAt: #dictionaryOfRootClassColors ifAbsentPut: nil! !

!MooseModel methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 6/30/2018 14:36'!
dictionaryOfRootClassColors: aCollection 
	self privateState attributeAt: #dictionaryOfRootClassColors put: aCollection ! !

!FAMIXPackage methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/8/2018 16:58'!
mouseAnnouncer
	^RTPopup new text: self viewInClassBluePrint! !

!FAMIXPackage methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/8/2018 16:58'!
packageViewIn: composite
	<gtInspectorPresentationOrder: -10>
	<moosePresentationOrder: -20>
	composite roassal2
		title: 'NameBlueprint';
		initializeView: [ self vocabularyScanner classBluePrint]! !

!FAMIXPackage methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/8/2018 16:58'!
viewInClassBluePrint
	^'package Name: ', (self vocabularyScanner classNamesScanReport at: 'packageName') asString! !

Object subclass: #HierarchyScanReportFillingExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Examples'!

!HierarchyScanReportFillingExample commentStamp: 'AbdelghaniAlidra 9/30/2018 09:38' prior: 0!
this class/method is not executable.
it is just inteded to give guidelines on how to update a HierarchyScanReport with manual analysis information!

!HierarchyScanReportFillingExample methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 9/30/2018 16:47'!
example1
"this class/method is not executable.
it is just inteded to give guidelines on how to update a HierarchyScanReport with manual analysis information"
| aGroupOfPackagesScanReport associations |
associations := aGroupOfPackagesScanReport allIncoherentHierarchies .
associations do: [:each | each value 
	at: 'usesManySuffixes' put: 'YES'; "put yes if the hierarchy uses  more than one suffix"
	at: 'isFalsePositive' put: 'NO'; "put the name of the categorie of the false positive that violates the suffix unicity assumption : specialization, FrenchStyle, ... The false positive means that the hierarchy naming is coherent despite it violates the suffix unicity assumption
	Put NO otherwise "
	at: 'isHyerarchyNamedInconsistently' put: 'YES'; "put NO if the hierarchy uses many suffixes improperly and some classes should be renamed (independently from our assumptions)"
	at: 'noteOnHierarchyCoherence' put: 'some explanation on the disgnisis and how to fix in case of inconsistency'; 
	at: 'canBeFixedConformingToUnicityHypothesis' put: 'Unknown' "Put YES if you beleive that some classes could be renamed conforming to unicity hypothesis"
	].! !

!HierarchyScanReportFillingExample methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 10/13/2018 07:43'!
example3 
"Where self is a FAMIXPackagesGroupScanner"
self allHierarchies
		do: [ :aHierarchy | 
			aHierarchy classesGroupedBySuffixes
				do: [ :suffixAndClasses | 
					suffixAndClasses
						do: [ :each | 
							
							(each at: 'classSuffix') = (aHierarchy at: 'classSuffix') "Coherent Hierarchies and classes with same suffix as Root"
								ifTrue: [ each at: 'CLASSNAME_usesSameSuffixeAsRoot' put: 'YES'.
									each at: 'CLASSNAME_isFalsePositive' put: ''.
									each at: 'CLASSNAME_isNamedConsistently' put: 'YES'.
									each at: 'CLASSNAME_noteOnCoherence' put: ''.
									each at: 'CLASSNAME_canBeFixedConformingToUnicityHypothesis' put: '' ]
								ifFalse: [ "PLEASE Inspect self allIncoherentHierarchies and edit one by one" ] ] ].
	aHierarchy at: 'CLASSNAME_usesSameSuffixeAsRoot' put: ''.
	aHierarchy at: 'CLASSNAME_isNamedConsistently' put: ''.	
		aHierarchy at: 'CLASSNAME_noteOnCoherence' put: 'Root'
						].
	"then inspect the following :"
	self allIncoherentHierarchies. 	
		"and in the new window, click on each HierarchyReport then evaluate the correct expression between brackets (without the brackets)" 
					
	[self classesGroupedBySuffixes 
		do: [ :suffixAndClasses | 
			(suffixAndClasses first at: 'classSuffix') = (self at: 'classSuffix') ifFalse: [
			suffixAndClasses
	do: [ :each | 
	each at: 'CLASSNAME_usesSameSuffixeAsRoot' put: 'NO'.
	each at: 'CLASSNAME_isFalsePositive' put: 'Specialization'.
	each at: 'CLASSNAME_isNamedConsistently' put: 'YES'.
	each at: 'CLASSNAME_noteOnCoherence' put: ''.
	each at: 'CLASSNAME_canBeFixedConformingToUnicityHypothesis' put: '' ] ]]].

[ self classesGroupedBySuffixes 
		do: [ :suffixAndClasses | 
			(suffixAndClasses first at: 'classSuffix') = (self at: 'classSuffix') ifFalse: [
			suffixAndClasses
	do: [ :each | 
	each at: 'CLASSNAME_usesSameSuffixeAsRoot' put: 'NO'.
	each at: 'CLASSNAME_isFalsePositive' put: 'NO'.
	each at: 'CLASSNAME_isNamedConsistently' put: 'NO'.
	each at: 'CLASSNAME_noteOnCoherence' put: 'Improper suffix dropping'.
	each at: 'CLASSNAME_canBeFixedConformingToUnicityHypothesis' put: 'YES' ] ]] ].
			
[self classesGroupedBySuffixes 
		do: [ :suffixAndClasses | 
			(suffixAndClasses first at: 'classSuffix') = (self at: 'classSuffix') ifFalse: [
			suffixAndClasses
				do: [ :each | 
					each at: 'CLASSNAME_usesSameSuffixeAsRoot' put: 'NO'.
					each at: 'CLASSNAME_isFalsePositive' put: 'NO'.
					each at: 'CLASSNAME_isNamedConsistently' put: 'NO'.
					each at: 'CLASSNAME_noteOnCoherence' put: 'OLD CLass may be should be removed or renamed'.
					each
						at: 'CLASSNAME_canBeFixedConformingToUnicityHypothesis'
						put: 'YES' ] ]]].
		
[self classesGroupedBySuffixes 
		do: [ :suffixAndClasses | 
			false ifFalse: [
			suffixAndClasses
				do: [ :each | 
					each at: 'CLASSNAME_usesSameSuffixeAsRoot' put: 'UNKNOWN'.
					each at: 'CLASSNAME_isFalsePositive' put: 'UNKNOWN'.
					each at: 'CLASSNAME_isNamedConsistently' put: 'UNKNOWN'.
					each at: 'CLASSNAME_noteOnCoherence' put: 'UNKNOWN'.
					each
						at: 'CLASSNAME_canBeFixedConformingToUnicityHypothesis'
						put: 'UNKNOWN' ] ]]]			
			self generateCSVFor: 'Reports/Calypso'
! !

!Object methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 9/27/2018 14:08'!
viewInMooseIn: aGLMCompositePresentation ! !

Object subclass: #RunnableExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Reports'!

!RunnableExamples class methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 8/2/2018 10:02'!
loadInMoose: aClassHierarchy
	| packages model importer HierarchyToAnalze |
	HierarchyToAnalze := aClassHierarchy.
	model := MooseModel new.
	importer := MoosePharoImporterTask new model: model.
	importer
		importingContext:
			(MooseImportingContext new
				mergeClassAndMetaclass;
				importClass;
				importPackage;
				importInheritance;
				yourself).
	packages := HierarchyToAnalze allSubclasses collect: [ :each | each package name ] as: Set.
	packages do: [ :each | importer addFromPackageNamed: each ].
	importer run.
	model name: HierarchyToAnalze name.
	^ model install! !

Object subclass: #SuffixScanReportFillingExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer-Examples'!

!SuffixScanReportFillingExample commentStamp: 'AbdelghaniAlidra 9/29/2018 17:39' prior: 0!
this class/method is not executable.
it is just inteded to give guidelines on how to update a SuffixScanReport with manual analysis information!

!SuffixScanReportFillingExample methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 9/29/2018 17:38'!
example1
"this class/method is not executable.
it is just inteded to give guidelines on how to update a SuffixScanReport with manua analysis information"
| aGroupOfPackagesScanReport associations |
associations := aGroupOfPackagesScanReport allInCoherentSuffixes
associations do: [:each | each value 
	at: 'suffix:' put: self value suffix;
	at: 'isUsedInManyHierarchies' put: 'YES'; "put yes if the suffix is used in more than one hierarchy"
	at: 'isFalsePositive' put: 'NO'; "put the name of the categorie of the false positive that violates the concept unicity assumption : synonyms, GeneralTermSuffix, suffixDropping, SameSuffixDifferentRepresentations, ... The false positive means that the suffix is not ambiguous despite it violates the concept unicity assumption
	Put NO otherwise "
	at: 'isTrueAmbiguous' put: 'YES'; "put YES if the suffix is used improperly and some classes should be renamed"
	at: 'note' put: 'Why RTAction different from GLMRoassal2Action?'; "Explain why you consider the suffix is ambiguous/falsepositive"
	at: 'canBeFixedConformingToUnicityHypothesis' put: 'Unknown' "Put YES if you beleive that some classes could be renamed conforming to unicity hypothesis"
	].! !

!SuffixScanReportFillingExample methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 10/13/2018 07:35'!
example2
"Where self is aFAMIXPAckageGroupScanner :) "

self allCoherentSuffixes do: [:each | each value 
	at: 'suffix:' put: each value suffix;
	at: 'isUsedInManyHierarchies' put: 'NO'; 
	at: 'isFalsePositive' put: ''; 
	at: 'isTrueAmbiguous' put: ''; 
	at: 'note' put: ''; 
	at: 'canBeFixedConformingToUnicityHypothesis' put: '' 
	].

"then expect the following:"
self allInCoherentSuffixes do: [:each | each value 
	at: 'suffix:' put: each value suffix;
	at: 'isUsedInManyHierarchies' put: 'YES'].
"and in the new window, click on each suffixReport then evaluate the correct expression between brackets (without the brackets)"
[self value 
	at: 'isFalsePositive' put: 'GeneralTerm_Actor';
	at: 'isTrueAmbiguous' put: 'NO';
	at: 'note' put: 'Verb+ER/OR';
	at: 'canBeFixedConformingToUnicityHypothesis' put: '';
	at: 'others' put: ''.
	self value].
	
[self value 
	at: 'isFalsePositive' put: 'NO';
	at: 'isTrueAmbiguous' put: 'YES';
	at: 'note' put: 'Mostly Classes intended for test. Should be ignored';
	at: 'canBeFixedConformingToUnicityHypothesis' put: 'Whatever';
	at: 'others' put: ''.
	self value].

[ self value 
	at: 'isFalsePositive' put: 'GeneralTerm_Presuffix';
	at: 'isTrueAmbiguous' put: 'NO';
	at: 'note' put: 'depends on the pre-suffix';
	at: 'canBeFixedConformingToUnicityHypothesis' put: '';
	at: 'others' put: ''.
	self value ].

[ self value 
	at: 'isFalsePositive' put: 'NO';
	at: 'isTrueAmbiguous' put: 'YES';
	at: 'note' put: 'Improper suffix Dropping';
	at: 'canBeFixedConformingToUnicityHypothesis' put: 'YES';
	at: 'others' put: ''.
	self value ].

[  self value 
	at: 'isFalsePositive' put: 'NO';
	at: 'isTrueAmbiguous' put: 'YES';
	at: 'note' put: 'It is not obvious why a BrowserQueryCursor is different from ClosedQueryCursor';
	at: 'canBeFixedConformingToUnicityHypothesis' put: 'UNKNOWN';
	at: 'others' put: ''.
	self value  ]! !

Object subclass: #VocabularyScanner
	instanceVariableNames: 'classNamesScanReport scannedEntities definedMetrics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer'!

VocabularyScanner subclass: #FAMIXClassScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer'!

!FAMIXClassScanner class methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 4/27/2018 16:42'!
reportClass
	^ClassScanReport! !

!FAMIXClassScanner methodsFor: '*ClassNamesAnalyzer' stamp: 'AbdelghaniAlidra 10/8/2018 17:13'!
defaultMetrics
	"use 'aFAMIXClassScanner classNamesScanReport' whenever an expensive computation is required and has been computed in a previous metric
	Example : rootClass uses the metric superclasses"
	
		^ Dictionary new
		at: 'scannedClasses' put: [ :aFAMIXClassScanner | aFAMIXClassScanner scannedClass  ];
		at: 'className' put: [ :aFAMIXClassScanner | aFAMIXClassScanner scannedClass name ];
		at: 'classSuffix' put: [ :aFAMIXClassScanner | aFAMIXClassScanner scannedClass name splitWithCamelCase last];
		at: 'superclasses' put: [  :aFAMIXClassScanner | aFAMIXClassScanner scannedClass superclasses ];
		at: 'package' put: [  :aFAMIXClassScanner | aFAMIXClassScanner scannedClass parentPackage ];
		at: 'superclassesInCurrentPackage' put: [  :aFAMIXClassScanner | (aFAMIXClassScanner classNamesScanReport at: 'superclasses' ifAbsentPut: [  (self defaultMetrics at: 'superclasses') value: aFAMIXClassScanner  ]) select: [ :aFamixPackage| aFamixPackage parentPackage = aFAMIXClassScanner scannedClass parentPackage] ];
		at: 'superclasse' put: [  :aFAMIXClassScanner | aFAMIXClassScanner scannedClass superclass ];
		at: 'rootClass' put: [  :aFAMIXClassScanner | (aFAMIXClassScanner classNamesScanReport at: 'superclasses' ifAbsentPut: [  (self defaultMetrics at: 'superclasses') value: aFAMIXClassScanner  ]) first  ];
		at: 'isRoot' put: [ :aFAMIXClassScanner |
			scannedEntities isaRootClass
			] ;
		at: 'isMetaRoot' put: [ :aFAMIXClassScanner |
			scannedEntities isMetaRoot
			] ;
		"|className rootClassName| 
			className := aFAMIXClassScanner classNamesScanReport
				at: 'className'
				ifAbsentPut: [ (self defaultMetrics at: 'className') value: aFAMIXClassScanner ].
			rootClassName := (aFAMIXClassScanner classNamesScanReport
				at: 'rootClass'
				ifAbsentPut: [ (self defaultMetrics at: 'rootClass') value: aFAMIXClassScanner ]) name.
				
				className = rootClassName ]"


		yourself! !

!FAMIXClassScanner methodsFor: 'VocabularyScanning' stamp: 'AbdelghaniAlidra 7/8/2018 05:52'!
generateaClassNamesScanReport
	classNamesScanReport := ClassScanReport new.
	classNamesScanReport scannedEntity: scannedEntities.
	self definedMetrics associations do:[:each| classNamesScanReport at: each key ifAbsentPut: (each value value: self)].
	^classNamesScanReport! !

!FAMIXClassScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 12:03'!
scannedClass
	^ self scannedEntities! !

!FAMIXClassScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 12:03'!
scannedClass: aFAMIXClass 
	self scannedEntities: aFAMIXClass ! !

VocabularyScanner subclass: #FAMIXPackageScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer'!

!FAMIXPackageScanner class methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 4/27/2018 16:42'!
reportClass
	^PackageScanReport! !

!FAMIXPackageScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/9/2018 11:52'!
defaultMetrics
	
	^ Dictionary new
		at: 'numberOfPackages' put: [ :argh | 1 ];
		at: 'packageName' put: [ :argh | self scannedPackage name ];
		at: 'allClasses' put: [ :aSingleClassScanReports | aSingleClassScanReports collect: #scannedClass ];
		at: 'dominantRootsInSuffix' put: [ :aGroupOfScanReports | 
			((self classNamesScanReport at: 'rootClassesGroupedBySuffixes' ifAbsentPut: [(self defaultMetrics at:'rootClassesGroupedBySuffixes') value: aGroupOfScanReports]) collect: [:association|association key -> association value asBag sortedCounts])asDictionary];
		at: 'colorsOfRootClasses' put: [ :aSingleClassScanReports | self scannedPackage mooseModel dictionaryOfRootClassColors ];
		at: 'allRootClassesSortedByNumberOfSubClasses' put: [ :aGroupOfScanReports | ((self classNamesScanReport at: 'allRootClasses' ifAbsentPut: [(self defaultMetrics at:'allRootClasses') value: aGroupOfScanReports]) collect:#key) asBag sortedCounts];
		at: 'classNames'
			put:
				[ :aSingleClassScanReports | aSingleClassScanReports collect: [ :aSingleClassScanReport | aSingleClassScanReport at: 'className' ] ];
		at: 'classesAndSuffixes'
			put: [ :aSingleClassScanReports | 
			aSingleClassScanReports
				collect: [ :aSingleClassScanReport | (aSingleClassScanReport "scannedClass") -> (aSingleClassScanReport at: 'classSuffix') ] ];
			
		at: 'rootClassesGroupedBySuffixes'
			put: [ :aSingleClassScanReports | 
			| classesGroupedBySuffixes |
			classesGroupedBySuffixes := self classNamesScanReport
				at: 'classesGroupedBySuffixes'
				ifAbsentPut: [ (self defaultMetrics at: 'classesGroupedBySuffixes') value: aSingleClassScanReports ].
			classesGroupedBySuffixes associations collect: [:anAssociation| (anAssociation key -> (anAssociation value collect: [:each|each at:'rootClass']))]
				  ]	;
			
		at: 'classesGroupedBySuffixes'
			put: [ :aSingleClassScanReports | 
			| aDictionary classNamesAndSuffixes |
			aDictionary := Dictionary new.
			classNamesAndSuffixes := self classNamesScanReport
				at: 'classesAndSuffixes'
				ifAbsentPut: [ (self defaultMetrics at: 'classesAndSuffixes') value: aSingleClassScanReports ].
			classNamesAndSuffixes
				do: [ :anAssociation | 
					|aSuffix aClass classIsRoot|
					aSuffix := anAssociation value.
					aClass := anAssociation key.
					classIsRoot := aClass at: 'isRoot'" ifAbsentPut: [ (self defaultMetrics at: 'isRoot') value: aClass ]".
					aDictionary
						at: aSuffix
						ifPresent: [ (classIsRoot) ifTrue: [(aDictionary
								at: aSuffix)
								addFirst:
									 aClass;
										yourself]
									ifFalse: [ (aDictionary
								at: aSuffix)
								addLast:
									 aClass;
										yourself ] ]
						ifAbsentPut: [ OrderedCollection with: aClass ] ].
			aDictionary ];
		at: 'allClassNameSuffixes'
			put:
				[ :aSingleClassScanReports | aSingleClassScanReports collect: [ :aPackageScanReport | aPackageScanReport at: 'classSuffix' ] ];
			
		at: 'allClassNameSuffixesSorted'
			put: [ :aSingleClassScanReports | 
				|suffixScanReports|
				suffixScanReports := (aSingleClassScanReports collect:[:aSingleClassReport| SuffixScanReport with: aSingleClassReport]).
				self allClassNameSuffixesSorted: suffixScanReports
				];
			
		at: 'allClassNameSuffixesAsSet'
			put: [ :aSingleClassScanReports | 
			(self classNamesScanReport
				at: 'allClassNameSuffixesSorted'
				ifAbsentPut: [ (self defaultMetrics at: 'allClassNameSuffixesSorted') value: aSingleClassScanReports ])
				collect: #value ];
		at: 'allRootClasses'
			put:
				[ :aSingleClassScanReports | aSingleClassScanReports collect: [ :aSingleClassScanReport | (aSingleClassScanReport at: 'rootClass')->(aSingleClassScanReport) ] ];
		at: 'allRootClassesAsaSet'
			put: [ :aSingleClassScanReports | 
			(self classNamesScanReport
				at: 'allRootClasses'
				ifAbsentPut: [ (self defaultMetrics at: 'allRootClasses') value: aSingleClassScanReports ]) asSet ];
		yourself! !

!FAMIXPackageScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 7/14/2018 22:08'!
groupOfPackagesScanReport
	"Ugly hack. Should be removed once suffixes are grouped in a dedicated report"
	^self scannedEntities mooseModel allPackages vocabularyScanner classNamesScanReport! !

!FAMIXPackageScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 12:03'!
scannedPackage
	^ self scannedEntities! !

!FAMIXPackageScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 12:04'!
scannedPackage: aFAMIXPackage 
	self scannedEntities: aFAMIXPackage! !

!FAMIXPackageScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/30/2018 15:08'!
scannedPackages
	^{self scannedPackage}.! !

!FAMIXPackageScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 17:06'!
subEntities
	^self scannedPackage classes! !

VocabularyScanner subclass: #FAMIXPackagesGroupScanner
	instanceVariableNames: 'availableColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassNamesAnalyzer'!

!FAMIXPackagesGroupScanner class methodsFor: 'instance-creation' stamp: 'AbdelghaniAlidra 4/30/2018 00:04'!
allColors
	^(((Color colorNamesXKCD collect:#second) reject: [ :each|each size<3 ] )collect: [ :each|
	Color fromRgbTriplet: each ])! !

!FAMIXPackagesGroupScanner class methodsFor: 'instance-creation' stamp: 'AbdelghaniAlidra 4/27/2018 16:41'!
reportClass
	^GroupOfPackagesScanReport! !

!FAMIXPackagesGroupScanner class methodsFor: 'instance-creation' stamp: 'AbdelghaniAlidra 4/30/2018 09:17'!
scan: aFAMIXPackageGroup 
	"^(self new scannedEntities: aFAMIXPackageGroup) generateaClassNamesScanReport;yourself."
	^super scan: aFAMIXPackageGroup ! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/27/2018 14:33'!
allCoherentHierarchies
	^self allHierarchies select: [:each | each allHierarchySuffixes size = 1].! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/26/2018 19:13'!
allCoherentSuffixes
	^self allSuffixes select: [ :each | each value hierarchies asSet size = 1 ]! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/30/2018 21:54'!
allHierarchies
	^((self classNamesScanReport at: 'allRootClassesSortedByNumberOfSubClasses') reject: [ :each | each value classNamesScanReport at: 'isMetaRoot']) collect: [ :each | each value classNamesScanReport ].! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/27/2018 14:59'!
allInCoherentSuffixes
	^self allSuffixes select:  [ :each| each value hierarchies asSet size > 1 ]! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/29/2018 09:37'!
allIncoherentHierarchies
	^self allHierarchies select: [:each | each allHierarchySuffixes size > 1].! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/27/2018 14:49'!
allMultiClassCoherentHierarchies
	^self allMultiClassHierarchies select: [ :each| each allHierarchySuffixes size = 1 ]! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/27/2018 14:02'!
allMultiClassCoherentSuffixes
	^self allMultiClassSuffixes select: [ :each| each value hierarchies asSet size = 1 ]! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/27/2018 14:45'!
allMultiClassHierarchies
	^self allHierarchies select: [ :each | each scannedEntity allSubInheritances size >= 1 ]! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/26/2018 19:16'!
allMultiClassSuffixes
	^self allSuffixes select: [ :each | each key > 1 ]! !

!FAMIXPackagesGroupScanner methodsFor: 'queries' stamp: 'AbdelghaniAlidra 9/26/2018 19:10'!
allSuffixes
	^self classNamesScanReport at: 'allClassNameSuffixesSorted'.! !

!FAMIXPackagesGroupScanner methodsFor: 'instance-creation' stamp: 'AbdelghaniAlidra 7/28/2018 20:02'!
defaultMetrics
	^ Dictionary new
		at: 'numberOfPackages' put: [ :aGroupOfScanReports | aGroupOfScanReports size ];
		at: 'allClasses' put: [ :aGroupOfScanReports | aGroupOfScanReports flatCollect: [ :aPackageScanReport| aPackageScanReport at: 'allClasses']  ];
		at: 'classNames' put: [ :aGroupOfScanReports | aGroupOfScanReports flatCollect: [ :aPackageScanReport| aPackageScanReport at: 'classNames']];
		at: 'allRootClasses' put: [ :aGroupOfScanReports | aGroupOfScanReports flatCollect: [ :aPackageScanReport| aPackageScanReport at: 'allRootClasses']];
		
				at: 'hierarchiesGroupedBySuffixes' put: [ :aGroupOfScanReports | 
					((self classNamesScanReport at: 'allClassNameSuffixesSorted' ifAbsentPut: [(self defaultMetrics at:'allClassNameSuffixesSorted') value: aGroupOfScanReports]) collect: [:association|
						association value suffix->association value hierarchies]) asDictionary
					];

		
		at: 'allClassNameSuffixesSorted' put: [ :aGroupOfScanReports | 
			|suffixScanReports|
			suffixScanReports := ((self classNamesScanReport subEntityScanReports collect: [ :aPackageScanReport|  aPackageScanReport at: 'allClassNameSuffixesSorted']) flatCollect: #value)collect: #value.
			self allClassNameSuffixesSorted: suffixScanReports.
			
			"|aDictionary|
			aDictionary := Dictionary new.
(self classNamesScanReport at: 'allRootClasses' ifAbsentPut: [(self defaultMetrics at:'allRootClasses') value: aGroupOfScanReports]) collect: [:association|
	|suffix rootClass|
	suffix := association value at: 'classSuffix'.
	rootClass := association key.
	aDictionary at: suffix ifPresent: [(aDictionary at: suffix) add: rootClass ] ifAbsentPut: [Bag with: rootClass] ].
	aDictionary"];

		at: 'dominantRootsInSuffix' put: [ :aGroupOfScanReports | 
			((self classNamesScanReport at: 'hierarchiesGroupedBySuffixes' ifAbsentPut: [(self defaultMetrics at:'hierarchiesGroupedBySuffixes') value: aGroupOfScanReports])associations collect: [:association|association key -> association value sortedCounts])asDictionary];


		at: 'suffixesGroupedByRootClasses' put: [ :aGroupOfScanReports | 
			|aDictionary|
			aDictionary := Dictionary new.
(self classNamesScanReport at: 'allClassesGroupedByRootClasses' ifAbsentPut: [(self defaultMetrics at:'allClassesGroupedByRootClasses') value: aGroupOfScanReports]) associations collect: [:association|
	association key -> (association value collect: [:aReport| aReport at: 'classSuffix'])
	]];
		
		
		at: 'allClassesGroupedByRootClasses' put: [ :aGroupOfScanReports | 
			|aDictionary|
			aDictionary := Dictionary new.
			(self classNamesScanReport at: 'allRootClasses' ifAbsentPut: [(self defaultMetrics at:'allRootClasses') value: aGroupOfScanReports]) do:[:anAssociation|
				|root subClass|
				root := anAssociation key.
				subClass := anAssociation value.
				aDictionary at: root ifPresent: [ (aDictionary at: root) add: subClass;yourself ] ifAbsentPut: [ Bag with: subClass ]
			
				].
			aDictionary];
		
		at: 'allRootClassesSortedByNumberOfSubClasses' put: [ :aGroupOfScanReports | ((self classNamesScanReport at: 'allRootClasses' ifAbsentPut: [(self defaultMetrics at:'allRootClasses') value: aGroupOfScanReports]) collect:#key) asBag sortedCounts];
		
		at: 'allRootClassesAsaSet' put: [ :aGroupOfScanReports | (self classNamesScanReport at: 'allRootClassesSortedByNumberOfSubClasses' ifAbsentPut: [(self defaultMetrics at:'allRootClassesSortedByNumberOfSubClasses') value: aGroupOfScanReports] ) collect: #value ];
		
		at: 'colorsOfRootClasses' put: [ :aGroupOfScanReports | 
			self scannedEntities mooseModel dictionaryOfRootClassColors ifNil:
			[|aDictionaryOfColors i|
			i := 0.
			aDictionaryOfColors := Dictionary new.
			
			(self classNamesScanReport at: 'allRootClassesSortedByNumberOfSubClasses' ifAbsentPut: [(self defaultMetrics at:'allRootClassesSortedByNumberOfSubClasses') value: aGroupOfScanReports] ) do: [ :aRootClass| aRootClass value isMetaRoot ifTrue: [aDictionaryOfColors at: aRootClass value put: (Color gray: 1) ] ifFalse: [ i:= i+1. aDictionaryOfColors at: aRootClass value put: (self pickAnAvailableColorNumber: i) ]. self saveInMooseModel: aDictionaryOfColors ]]];
		
		yourself! !

!FAMIXPackagesGroupScanner methodsFor: 'storage' stamp: 'AbdelghaniAlidra 10/7/2018 19:47'!
generateCSVFor: aProject
	| stream anOutputFileName |
	
	anOutputFileName := aProject, Date today yyyymmdd, Time now hhmm24,'.txt'.
	[ stream := anOutputFileName asFileReference writeStream.
	stream setToEnd.
	stream << 'Project '<< ';' << aProject.
	stream crlf.
	stream << 'numberOfSuffixes'<< ';' << self allSuffixes size asString.
	stream crlf.
	stream << 'numberOfCoherentSuffixes'<< ';' << self allCoherentSuffixes size asString.
	stream crlf.
	stream << 'numberOfMultiClassSuffixes'<< ';' << self allMultiClassSuffixes size asString.
	stream crlf.
	stream << 'numberOfMultiClassCoherentSuffixes'<< ';' << self allMultiClassCoherentSuffixes size asString.
	stream crlf.stream crlf.
	stream << 'numberOfHierarchies'<< ';' << self allHierarchies size asString.
	stream crlf.
	stream << 'numberOfCoherentHierarchies'<< ';' << self allCoherentHierarchies size asString.
	stream crlf.
	stream << 'numberOfMultiClassHierarchies'<< ';' << self allMultiClassHierarchies size asString.
	stream crlf.
	stream << 'numberOfMultiClassCoherentHierarchies'<< ';' << self allMultiClassCoherentHierarchies size asString.
	stream crlf.
	] ensure:[stream close].

	self generateCSVSuffixReportFor: aProject.
"anOutputFileName := aProject, 'HierarchiesReport', Date today yyyymmdd, '_', Time now hhmm24,'.txt'.
	[ stream := anOutputFileName asFileReference writeStream.
	stream setToEnd.
	stream << 'Hierarchy;HIERARHCY_usesManySuffixes;HIERARHCY_isFalsePositive;HIERARHCY_isNamedInconsistently;HIERARHCY_noteOnCoherence;HIERARHCY_canBeFixedConformingToUnicityHypothesis'.
	stream crlf.
self allHierarchies do: [ :aHierarchyScanReport| 
		aHierarchyScanReport value saveTo: stream].
	] ensure:[stream close].
"
	self generateCSVHierarchyFor: aProject.
! !

!FAMIXPackagesGroupScanner methodsFor: 'storage' stamp: 'AbdelghaniAlidra 10/7/2018 19:47'!
generateCSVHierarchyFor: aProject
	| anOutputFileName stream |
	anOutputFileName := aProject, 'ClassesReport', Date today yyyymmdd, '_', Time now hhmm24,'.txt'.
	[ stream := anOutputFileName asFileReference writeStream.
	stream setToEnd.
	stream << 'ClassName;HierarchyName; CLASSNAME_usesSameSuffixeAsRoot;CLASSNAME_isFalsePositive;CLASSNAME_isNamedConsistently;CLASSNAME_noteOnCoherence;CLASSNAME_canBeFixedConformingToUnicityHypothesis'.
	stream crlf.
(self classNamesScanReport at: 'allClasses') do: [ :aClass| 
		(aClass classNamesScanReport at: 'isMetaRoot') ifFalse: [aClass classNamesScanReport saveClassNameInformationTo: stream]].
	] ensure:[stream close].
! !

!FAMIXPackagesGroupScanner methodsFor: 'storage' stamp: 'AbdelghaniAlidra 10/7/2018 19:45'!
generateCSVSuffixReportFor: aProject
	| stream anOutputFileName |
	
	anOutputFileName := aProject, 'SuffixReport', Date today yyyymmdd, '_', Time now hhmm24,'.txt'.
	[ stream := anOutputFileName asFileReference writeStream.
	stream setToEnd.
	stream << 'suffix;isUsedInManyHierarchies;isFalsePositive;isTrueAmbiguous;note;canBeFixedConformingToUnicityHypothesis'.
	stream crlf.
self allSuffixes do: [ :aSuffixScanReport| 
		aSuffixScanReport value saveTo: stream].
	] ensure:[stream close].
! !

!FAMIXPackagesGroupScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 5/7/2018 09:42'!
groupOfPackagesScanReport
	^ self classNamesScanReport! !

!FAMIXPackagesGroupScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/29/2018 23:59'!
initialize
	super initialize.
	availableColors := self class allColors! !

!FAMIXPackagesGroupScanner methodsFor: 'VocabularyScanning' stamp: 'AbdelghaniAlidra 4/27/2018 11:41'!
mergeSinglePackageScanReports: aCollectionOfPackageScanReports 
	self 
		deprecated: 'Use generateaClassNamesScanReport instead'
		on: 	'27 April 2018' 
		in: 'Pharo-5.0-50761-'.
	^ self generateaClassNamesScanReport ! !

!FAMIXPackagesGroupScanner methodsFor: 'instance-creation' stamp: 'AbdelghaniAlidra 7/10/2018 18:58'!
pickAnAvailableColorNumber: indexOfColors
"Color grey: 1 is used for Meta Root classes"
	indexOfColors <= (availableColors size) ifTrue:[^availableColors at: indexOfColors]
	ifFalse:[ ^Color gray: indexOfColors / (availableColors size) ]! !

!FAMIXPackagesGroupScanner methodsFor: 'instance-creation' stamp: 'AbdelghaniAlidra 6/30/2018 14:37'!
saveInMooseModel: aDictionaryOfColors
	self scannedPackages mooseModel dictionaryOfRootClassColors: aDictionaryOfColors.
	^aDictionaryOfColors! !

!FAMIXPackagesGroupScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 12:00'!
scannedPackages
	^ self scannedEntities! !

!FAMIXPackagesGroupScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 12:01'!
scannedPackages: aFAMIXPackageGroup 
	self scannedEntities: aFAMIXPackageGroup ! !

!FAMIXPackagesGroupScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 17:05'!
subEntities
	^self scannedPackages.! !

!VocabularyScanner class methodsFor: 'as yet unclassified' stamp: 'AbdelghaniAlidra 4/27/2018 12:12'!
defaultMetrics
	^self subclassResponsibility! !

!VocabularyScanner class methodsFor: 'instance-creation' stamp: 'AbdelghaniAlidra 4/27/2018 16:41'!
reportClass
	^self subclassResponsibility! !

!VocabularyScanner class methodsFor: 'instance-creation' stamp: 'AbdelghaniAlidra 7/14/2018 21:29'!
scan: aFAMIXPackageGroup 
	|aVocabularyScanner|
	
	aVocabularyScanner := (self new scannedEntities: aFAMIXPackageGroup) generateaClassNamesScanReport;yourself.
	aFAMIXPackageGroup vocabularyScanner: aVocabularyScanner.
	^aVocabularyScanner! !

!VocabularyScanner methodsFor: 'metrics' stamp: 'AbdelghaniAlidra 4/27/2018 16:52'!
addaMetric: metricName with: aBlock
	definedMetrics at: metricName put: aBlock
	! !

!VocabularyScanner methodsFor: 'metrics' stamp: 'AbdelghaniAlidra 7/10/2018 23:04'!
allClassNameSuffixesSorted: suffixScanReports

	| agregatedSuffixScanReports |
	agregatedSuffixScanReports := OrderedCollection new.
				[suffixScanReports notEmpty] whileTrue: [ 
				|aSuffixDescriptor descriptorsOfSameSuffix indexesOfDescriptorsOfSameSuffix| 
				indexesOfDescriptorsOfSameSuffix := OrderedCollection new.
				aSuffixDescriptor := suffixScanReports first.
				suffixScanReports removeFirst.
				1 to: suffixScanReports size do: [:index| (((suffixScanReports at:index) suffix) = aSuffixDescriptor suffix) ifTrue: [indexesOfDescriptorsOfSameSuffix add: index]].
				descriptorsOfSameSuffix := indexesOfDescriptorsOfSameSuffix collect: [ :i| suffixScanReports at: i ].
				
				aSuffixDescriptor mergeWith: descriptorsOfSameSuffix.
				"aSuffixDescriptor at: #suffix put: aSuffixDescriptor suffix."
				agregatedSuffixScanReports add: aSuffixDescriptor.
				
							indexesOfDescriptorsOfSameSuffix reversed do: [:i| suffixScanReports removeAt: i]
				]. 
				agregatedSuffixScanReports sort: [:first :second| first numberOfClasses > second numberOfClasses].
				^agregatedSuffixScanReports collect: [ :each| each numberOfClasses->each  ].
! !

!VocabularyScanner methodsFor: 'Visualizations' stamp: 'AbdelghaniAlidra 7/30/2018 18:49'!
classBluePrint
		| b sortedRootClasses  delay |
	^classNamesScanReport at: 'classBlueprint' ifAbsentPut:[ 	b := RTMondrian new.
			delay:=Time now.
			
	"TimeProfiler spyOn:["sortedRootClasses := (self classNamesScanReport
		at: 'allRootClassesSortedByNumberOfSubClasses') collect: #value.
	"dictionaryOfColors := self classNamesScanReport
		at: 'colorsOfRootClasses'."
	b shape rectangle withTextAbove.
	b shape color: [ :each| Color white ];
	borderColor: [ :aPackage| Color gray ] .
	b
		nodes: self scannedPackages
		forEach: [ :aSinglePackage | 
			| aSinglePackageScanReport sortedSuffixes unSortedSuffixes |
			aSinglePackageScanReport := aSinglePackage vocabularyScanner
				classNamesScanReport.
			b shape rectangle.
			b shape
				color: [ :aSuffix | 
					| dominantClasse |
					dominantClasse := ((self groupOfPackagesScanReport
						at: 'dominantRootsInSuffix') at: aSuffix value suffix) first value.
						"if DictionaryOfColors is nil this means that the group of packages has not been scanned yet. Then scan it"
						self dictionaryOfColors ifNil:[
							self scannedEntities mooseModel allPackages scanClassNames
							].
					(self dictionaryOfColors at: dominantClasse) alpha: ((aSuffix value dominantHierarchieInPackages select: [ :each| each value >= aSuffix value dominanceLevel ]) size / aSuffix value dominantHierarchieInPackages size) ];
				withTextAbove: [:each| each value suffix];
				borderWidth: 2.
							b shape borderColor: [  :aSuffix | 
					| dominantClasse |
					dominantClasse := ((self groupOfPackagesScanReport
						at: 'dominantRootsInSuffix') at: aSuffix value suffix) first value.
					(self dictionaryOfColors at: dominantClasse)  ] .
unSortedSuffixes := (self groupOfPackagesScanReport at: 'allClassNameSuffixesSorted') select: [ :association| association value packages includes: aSinglePackageScanReport scannedEntity ]  .
"sortedSuffixes := sortedSuffixes sort: [ :first :second | (first value dominantHierarchie key first = second value dominantHierarchie key first) and: ].
"
sortedSuffixes := aSinglePackageScanReport sortSuffixes: unSortedSuffixes.
			b
				nodes: sortedSuffixes
				forEach: [ :suffix | 
					
					b shape rectangle.
					b shape
						size:
							[ :aClassScanReport | 50 / ((aClassScanReport at: 'superclassesInCurrentPackage') size + 1) ].
					b shape
						color: [ :aClassScanReport | 
							 self dictionaryOfColors at: (aClassScanReport at: 'rootClass')  ];
						borderColor: [ :aClassScanReport | 
							(aClassScanReport at: 'className')
								= (aClassScanReport at: 'rootClass') name
								ifTrue: [ Color black ]
								ifFalse: [ (self dictionaryOfColors at: (aClassScanReport at: 'rootClass'))
										adjustBrightness: -0.1 ] ];
						borderWidth: 1.
					b
						nodes:
							((aSinglePackageScanReport at: 'classesGroupedBySuffixes')
								at: suffix value suffix).
								
					
					b layout grid ].
			b layout grid ].
	b layout grid.
	
	
	b view elements do: [ :element| element announcer subscriptions  subscriptions do: [ :each | element announcer subscriptions  subscriptions remove: each ]].
	b view elements do: [ :element| element @ (element model mouseAnnouncer)].

b shape line color: (Color white alpha: 0.05).
	b edges: ((self classNamesScanReport at:'allClasses') collect: [ :each| 
								each vocabularyScanner classNamesScanReport ]) from: #yourself to: [ :aClassScanReport| (aClassScanReport at: 'superclasse') ifNotNil: [ (aClassScanReport at: 'superclasse') vocabularyScanner classNamesScanReport ] ]."]"
	
	Transcript show: (Time now asSeconds - delay asSeconds )asString;cr.
	
	
	^ b
	]! !

!VocabularyScanner methodsFor: 'Accessing' stamp: 'AbdelghaniAlidra 4/27/2018 18:30'!
classNamesScanReport
	^ classNamesScanReport! !

!VocabularyScanner methodsFor: 'metrics' stamp: 'AbdelghaniAlidra 4/27/2018 16:53'!
definedMetricNames
	^definedMetrics allKeys
	! !

!VocabularyScanner methodsFor: 'metrics' stamp: 'AbdelghaniAlidra 4/27/2018 16:53'!
definedMetrics
	^definedMetrics
	! !

!VocabularyScanner methodsFor: 'instance-creation' stamp: 'AbdelghaniAlidra 7/28/2018 19:28'!
dictionaryOfColors

	^self scannedEntities mooseModel dictionaryOfRootClassColors! !

!VocabularyScanner methodsFor: 'VocabularyScanning' stamp: 'AbdelghaniAlidra 4/30/2018 14:21'!
generateaClassNamesScanReport
	| subEntityScanReports |
	classNamesScanReport := self reportClass new.
	classNamesScanReport scannedEntity: scannedEntities.
	subEntityScanReports := (self subEntities collect: #scanClassNames) collect: #classNamesScanReport.
	classNamesScanReport subEntityScanReports: subEntityScanReports.
	self definedMetrics associations do:[:each| 
		classNamesScanReport at: each key ifAbsentPut: (each value value: (subEntityScanReports))].
	^classNamesScanReport.
! !

!VocabularyScanner methodsFor: 'initialization' stamp: 'AbdelghaniAlidra 4/27/2018 18:43'!
initialize
	super initialize.
	definedMetrics := self defaultMetrics.! !

!VocabularyScanner methodsFor: 'metrics' stamp: 'AbdelghaniAlidra 4/27/2018 16:53'!
removeaMetrics: metricName
	definedMetrics removeKey: metricName ifAbsent: [  ]
	! !

!VocabularyScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 16:40'!
reportClass
	^self class reportClass! !

!VocabularyScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 12:04'!
scannedEntities
	^ scannedEntities! !

!VocabularyScanner methodsFor: 'accessing' stamp: 'AbdelghaniAlidra 4/27/2018 12:02'!
scannedEntities: aFAMIXClassOrPackageOrPackageGroup 
	scannedEntities := aFAMIXClassOrPackageOrPackageGroup! !
